## crawl 0.10.0

=== source/Makefile ===
#
# Dungeon Crawl Stone Soup
# GNU Makefile
#
# largely written by Steven Noonan <steven@uplinklabs.net>
#    (if something breaks, blame him.)
#

# Typical targets:
#    make
#    make debug
#    make debug-lite    # Like "make debug", but without all the spew.
#    make install
#    make debug install
#    -- note, unlike most programs, you need to specify build type when
#       installing even if you just built it.
# Typical parameters:
#    TILES         -- set to anything to enable tiles build
#
#    CROSSHOST     -- target system, eg, i386-pc-msdosdjgpp or i586-mingw32msvc
#
#    prefix        -- installation base.  Specify eg. /usr/local on Unix systems.
#    DESTDIR       -- installation staging area (the dir you intend to pack)
#    DATADIR       -- place to hold immutable files.  Can be either relative to
#                     "prefix" or absolute.
#    SAVEDIR       -- place to hold writeable data (saves, database, morgue
#                     dumps).  Can be relative to "prefix", absolute or placed
#                     in the user's home dir (~).  Remember to protect the ~
#                     from your shell!
#                     Warning, shared directories are no longer supported.
#    SHAREDDIR     -- place to hold writeable data common to multiple
#                     players (scores, the logfile, ghosts).  Will be placed
#                     inside the SAVEDIR if not specified.
#       Layout examples:
#         prefix=~/crawl DATADIR=data/ SAVEDIR=saves/
#                  -- everything under ~/crawl
#         prefix=/usr/local
#                  -- system-wide installation
#
#    V             -- set to anything to enable verbose build
#
#    USE_ICC       -- set to use Intel's compiler
#    LTO           -- set for better optimization but slower compilation,
#                     requires gcc4.6+
#    ASSERTS       -- set to enable assertion checks (implied in debug mode)
#    NOWIZARD      -- set to disable wizard mode.  Use if you have untrusted
#                     remote players without DGL.
#
#    WEBTILES      -- set to anything to compile for Webtiles
#    WEBDIR        -- place to hold the Webtiles client data. Can be either
#                     relative to prefix or absolute.
#
#
# Requirements:
#    For tile builds, you need pkg-config.
#    You also need libpng, sdl, sdl-image and libfreetype -- if you got your
#    source from git, you can 'git submodule update' to fetch them; you can also
#    ask for a package with convenience libraries instead -- we'll try to provide
#    them somewhere in the near future.

GAME = crawl

ASSERTS = yes

# Disable GNU Make implicit rules and variables. Leaving them enabled will slow
# down MinGW and Cygwin builds by a very VERY noticeable degree. Besides, we have
# _explicit_ rules defined for everything. So we don't need them.
MAKEFLAGS += -rR # This only works for recursive makes, i.e. contribs ...
.SUFFIXES:       # ... so zap the suffix list to neutralize most predifined rules, too

.PHONY: all test install clean clean-contrib clean-rltiles distclean debug debug-lite \
        profile package-source source build-windows package-windows rest docs greet \
        api

include Makefile.obj

#
# Compiler Flags
#
# The compiler flag variables are separated into their individual
# purposes, making it easier to deal with the various tools involved
# in a compile.
#
# These are also divided into global vs. local flags. So for instance,
# CFOPTIMIZE affects Crawl, Lua, and SQLite, while CFOPTIMIZE_L only
# affects Crawl.
#
# The variables are as follows:
# CFOPTIMIZE(_L) - Optimization flags
# CFWARN(_L) - Warning flags
# CFOTHERS(_L) - Anything else
#


ifdef USE_ICC

# If you have a Core 2 processor, this _really_ makes things fly:
#CFOPTIMIZE := -O2 -parallel -xT

# Optionally enable the 'ipo' feature, to facilitate inlining
# across object file bounds.
#CFOPTIMIZE_L := -ipo

# Some very good optimization flags.
CFOPTIMIZE := -O2 -parallel

else

CFOPTIMIZE := -O2

endif # USE_ICC

ifdef LTO
CFOPTIMIZE += -flto=jobserver -fwhole-program
endif

CFOTHERS := -pipe $(EXTERNAL_FLAGS)
CFWARN := -Wall -Wformat-security
CFWARN_L := -Wundef

DEFINES := $(EXTERNAL_DEFINES)

LDFLAGS := $(EXTERNAL_LDFLAGS)

#
# The GCC and GXX variables are set later.
#
AR = ar
RANLIB = ranlib
CC = $(GCC)
CXX = $(GXX)
RM = rm -f
COPY = cp
COPY_R = cp -r
STRIP = strip -s
WINDRES = windres
CHMOD = chmod 2>/dev/null
CHOWN = chown 2>/dev/null
PNGCRUSH = $(COPY)
PNGCRUSH_LABEL = COPY
ADVPNG = advpng -z -4
PKGCONFIG = pkg-config
DOXYGEN = doxygen
DOXYGEN_SIMPLE_CONF = crawl_simple.doxy
DOXYGEN_ALL_CONF = crawl_all.doxy
DOXYGEN_HTML_GEN = html/

export AR
export RANLIB
export RM
export CC
export CXX
export CFLAGS
export MAKEFLAGS
export CONFIGURE_FLAGS
export uname_S

#
# Platform Detection
#
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
uname_O := $(shell sh -c 'uname -o 2>/dev/null || echo not')
uname_R := $(shell sh -c 'uname -r 2>/dev/null || echo not')
uname_P := $(shell sh -c 'uname -p 2>/dev/null || echo not')
uname_V := $(shell sh -c 'uname -v 2>/dev/null || echo not')

HOST := $(shell sh -c 'cc -dumpmachine || echo unknown')
ARCH := $(HOST)

ifdef CROSSHOST
	ARCH := $(CROSSHOST)
	ifneq (,$($shell which $(ARCH)-pkg-config 2>/dev/null))
	  PKGCONFIG = $(ARCH)-pkg-config
	else
	  ifneq (,$(wildcard /usr/$(ARCH)/lib/pkgconfig))
	    PKGCONFIG = PKG_CONFIG_LIBDIR=/usr/$(ARCH)/lib/pkgconfig pkg-config
	  else
	    NO_PKGCONFIG = YesPlease
	    BUILD_LUA = yes
	    BUILD_SQLITE = yes
	    BUILD_ZLIB = YesPlease
	  endif
	endif
	NO_AUTO_OPT = YesPlease
	CONFIGURE_FLAGS += --host=$(CROSSHOST)

	# If needed, override uname_S so we get the appropriate
	# things compiled.
	ifneq (,$(findstring mingw,$(CROSSHOST)))
		uname_S=MINGW32
	endif

endif
ifneq (,$(findstring MINGW,$(uname_S)))
	GAME = crawl.exe
	bin_prefix = .
	WIN32 = Yes
	NO_RDYNAMIC = YesPlease
	NO_NCURSES = YesPlease
	NEED_LIBW32C = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_ZLIB = YesPlease
	DEFINES_L += -DWINMM_PLAY_SOUNDS
	EXTRA_LIBS += -lwinmm
	ifdef TILES
		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm contrib/install/$(ARCH)/lib/libSDLmain.a -mwindows
		BUILD_FREETYPE = YesPlease
		BUILD_SDL = YesPlease
		BUILD_SDLIMAGE = YesPlease
		BUILD_LIBPNG = YesPlease
	endif
	ifeq ($(shell gcc -v -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
		EXTRA_LIBS += -static-libgcc -static-libstdc++
	endif
endif
ifeq ($(uname_S),Darwin)
	STRIP := strip -x
	NEED_APPKIT = YesPlease
	LIBNCURSES_IS_UNICODE = Yes
	NO_PKGCONFIG = Yes
	BUILD_SQLITE = YesPlease
	BUILD_ZLIB = YesPlease
	ifdef TILES
		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL contrib/install/$(ARCH)/lib/libSDLmain.a
		BUILD_FREETYPE = YesPlease
		BUILD_SDL = YesPlease
		BUILD_SDLIMAGE = YesPlease
		BUILD_LIBPNG = YesPlease
	endif
endif
ifdef USE_LUAJIT
	BUILD_LUA := YesPlease
endif
ifdef USE_ICC
	NO_RDYNAMIC := YesPlease
endif
ifneq (,$(findstring CYGWIN,$(uname_S)))
	GAME = crawl.exe
	NO_RDYNAMIC = YesPlease
	BUILD_PCRE = YesPlease
endif

ifdef BUILD_ALL
	BUILD_FREETYPE = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_SDL = YesPlease
	BUILD_SDLIMAGE = YesPlease
	BUILD_SQLITE = YesPlease
	BUILD_LUA = YesPlease
	BUILD_LIBPNG = YesPlease
	BUILD_ZLIB = YesPlease
endif

# Should be the first rule, but must come after $(GAME) is set.
all: greet $(GAME) docs webserver

LIBPCRE := contrib/install/$(ARCH)/lib/libpcre.a
LIBSDL := contrib/install/$(ARCH)/lib/libSDL.a
LIBPNG := contrib/install/$(ARCH)/lib/libpng.a
LIBSDLIMAGE := contrib/install/$(ARCH)/lib/libSDL_image.a
LIBFREETYPE := contrib/install/$(ARCH)/lib/libfreetype.a
LIBSQLITE := contrib/install/$(ARCH)/lib/libsqlite3.a
ifdef USE_LUAJIT
LIBLUA := contrib/install/$(ARCH)/lib/libluajit.a
else
LIBLUA := contrib/install/$(ARCH)/lib/liblua.a
endif
LIBZ := contrib/install/$(ARCH)/lib/libz.a

ifndef CROSSHOST
	LUA_INCLUDE_DIR := /usr/include/lua5.1
	SQLITE_INCLUDE_DIR := /usr/include
else
	# This is totally wrong, works only with some old-style setups, and
	# on some architectures of Debian/new FHS multiarch -- excluding, for
	# example, i386.  Fortunately, i386 is rarely cross-compiled to.
	# There's no support for /usr/local/ too, without thorough handholding.
	# It's still an improvement over Crawl 0.8 which had no cross-compiling
	# to non-win32 at all.
	#
	# Needs to be replaced by compile checks.  Guessing the paths is fragile,
	# while the compiler knows them already.
	LUA_INCLUDE_DIR := /usr/$(ARCH)/include/lua5.1
	SQLITE_INCLUDE_DIR := /usr/$(ARCH)/include
endif
LUA_LIB := -llua5.1
SQLITE_LIB := -lsqlite3

#
# Set up the TILES variant
#
ifdef TILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(GLTILES_OBJECTS)
endif

ifdef WEBTILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(WEBTILES_OBJECTS)
endif

#
# Check for an Apple-released compiler.
#
ifndef NO_APPLE_GCC
ifeq ($(uname_S),Darwin)
ifneq ($(shell gcc -v 2>&1 | grep Apple),)
APPLE_GCC = YesPlease
endif
endif
endif


ifdef WIN32
EXTRA_OBJECTS += icon.o
else
EXTRA_LIBS += -pthread
endif

ifndef TILES
ifdef NEED_LIBW32C
OBJECTS += libw32c.o
else
OBJECTS += libunix.o
endif
endif

# To get stack trace symbols.
# Note that MinGW doesn't support -rdynamic.
ifndef NO_RDYNAMIC
LDFLAGS += -rdynamic
endif

ifdef USE_MERGE_BASE
MERGE_BASE := $(shell git merge-base HEAD $(USE_MERGE_BASE))
endif

ifdef USE_DGAMELAUNCH
# Permissions to set on the game executable.
MCHMOD := 755

# Permissions to set on the save directory.
MCHMOD_SAVEDIR := 775
MCHMOD_LOGS := 664

# The user:group to install the game as.
INSTALL_UGRP := games:games
endif

chroot_prefix :=
prefix        :=

ifeq ($(patsubst %/local,%,$(patsubst %/,%,$(prefix))),/usr)
FHS := yes
endif

ifeq (,$(bin_prefix))
ifneq ($(patsubst %/,%,$(prefix)),/usr)
bin_prefix    := bin
else
bin_prefix    := games
endif
endif

# If you're installing Crawl for multiple users, you *must* set this to a
# valid path before building Crawl. This is not necessary if you are building
# Crawl for a single user.
# If you're installing to /usr or /usr/local, we have sane defaults.

# SAVEDIR := saves/
# DATADIR := data/
ifneq (,$(FHS))
DATADIR       := share/crawl
SAVEDIR       := ~/.crawl
endif

ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
DATADIR := data
SAVEDIR := ~/.crawl
endif


INCLUDES_L += -Icontrib/install/$(ARCH)/include
LIBS += -Lcontrib/install/$(ARCH)/lib

INCLUDES_L += -Iutil -I.

ifdef APPLE_GCC

MARCH := $(uname_M)


ifndef NO_AUTO_SDK

# Find the oldest SDK available, in attempt to make this build as
# backward-compatible as we possibly can.
SDK_VER := $(shell ls /Developer/SDKs | sort -n | head -1 | perl -pe 's/^MacOSX//g;s/.sdk$$//g')

ifeq ($(SDK_VER),10.4u)
SDK_VER := 10.4
endif

ifndef SDK_VER
$(error You do not seem to have any Mac OS X SDKs installed! This build is doomed to fail)
endif

endif

ifndef SDK_VER
ifeq ($(MARCH),ppc)
SDK_VER := 10.4
endif
ifeq ($(MARCH),i386)
SDK_VER := 10.4
endif
ifeq ($(MARCH),x86_64)
ifdef TILES
SDK_VER := 10.6
else
SDK_VER := 10.5
endif
endif
endif

# Mac OS X 10.4 adds a 'u' on the end of the SDK name. Everything
# else is much easier to predict the name of.
ifeq ($(SDK_VER),10.4)
GCC_VER := 4.0
SDKROOT := /Developer/SDKs/MacOSX$(SDK_VER)u.sdk
else
SDKROOT := /Developer/SDKs/MacOSX$(SDK_VER).sdk
endif

ifneq ($(shell test -d $(SDKROOT) || echo NOPE),)
$(error The Mac OS X $(SDK_VER) SDK seems missing)
endif

ifdef BUILD_UNIVERSAL
# [ds] 10.4 SDK g++-4.0 + x86_64 runs into SDL compile issues.
CFLAGS_ARCH := -arch i386 -arch ppc -faltivec
CFLAGS_DEPCC_ARCH := -arch i386
else
CFLAGS_ARCH := -arch $(MARCH)
endif

CC = $(GCC) $(CFLAGS_ARCH) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)
CXX = $(GXX) $(CFLAGS_ARCH) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)
DEPCC = $(GCC) $(or $(CFLAGS_DEPCC_ARCH),$(CFLAGS_ARCH)) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)

=== debian/changelog ===
crawl (2:0.10.0-2) unstable; urgency=low

  * Fix link to .txt files in /usr/share/doc/crawl-common/. Closes: #660388
  * Fix link to Stone Soup icon. Closes: #647464

 -- Guus Sliepen <guus@debian.org>  Sun, 19 Feb 2012 19:27:10 +0100

crawl (2:0.10.0-1) unstable; urgency=low

  [ Adam Borowski ]
  * New upstream release.
  * Obey flags set by dpkg-buildflags.
  * Work around breakage of quiltless workflows in dpkg 1.16.1.
  * Correct a symlink to the 32x32 icon. Closes: #647464
  * Install the SVG icon as well.
  * Don't request wizmode, it is compiled in by default.

  [ Guus Sliepen ]
  * Don't let the upstream Makefile strip binaries.

 -- Guus Sliepen <guus@debian.org>  Fri, 17 Feb 2012 21:17:51 +0100

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

ifneq (,$(shell gcc --version|grep 'gcc (.*) 4\.4\.'))
  ifeq ($(DEB_HOST_ARCH),powerpc)
	# g++-4.4 has an ICE there.
	DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) noopt
  endif
endif
CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) $(shell dpkg-buildflags --get LDFLAGS)

tree-stamp:
	dh_testdir
	mkdir build-console
	cp -ldpR docs settings source CREDITS.txt build-console/
	mkdir build-tiles
	cp -ldpR docs settings source CREDITS.txt build-tiles/
	touch tree-stamp

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
endif

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" $(CROSS)
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf

build-arch build-indep: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles

	git clean -dfX || true

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
	#	mv crawl/docs/* doc/crawl-common && \
	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
	rm -rf debian/crawl-common/usr/share/crawl/docs/license
	mkdir -p debian/crawl/usr/
	mv debian/crawl-common/usr/games debian/crawl/usr/games
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	rm -rf debian/crawl-tiles/var
	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
	cd debian/crawl-tiles/usr/share/crawl/dat && rm -rf des dlua database descript lua
	
	mkdir -p debian/crawl/usr/share/man/man6
	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
	mkdir -p debian/crawl-tiles/usr/share/man/man6
	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
	for i in docs/*.txt; do \
		ln -sf /usr/share/crawl/$$i debian/crawl-common/usr/share/doc/crawl-common/; \
	done

	mkdir -p debian/crawl/usr/share/doc
	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
	mkdir -p debian/crawl-tiles/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
	dh_link -pcrawl-tiles usr/share/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/icons/hicolor/32x32/apps/crawl.png
	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps
	cp -p source/util/dcss.svg \
		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.png

# Build architecture-independent files here.
binary-indep: install
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common -Xcrawl_manual.txt -Xaptitudes.txt -Xquickstart.txt -Xmacros_guide.txt -Xoptions_guide.txt -Xtiles_help.txt
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_link -i
	dh_compress -i -Xaptitudes.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installmenu -a
	dh_link -a
	dh_compress -a -Xaptitudes.txt
	dh_strip -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build: build-indep build-arch
binary: binary-indep binary-arch
.PHONY: build-indep build-arch build clean binary-indep binary-arch binary install

## crawl 0.10.2

=== source/rltiles/Makefile ===
uname_S := $(shell uname -s)

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lmingw32
endif

# Note: since generation of tiles is done on the host, we don't care about
# cross-compilation here.
#
# Also, cross-compilation with no system libraries for host rather than target
# is not supported.  If host=target, contribs are enough.

CFLAGS := -O2 -g -Wall -Wextra -Wno-parentheses -Wno-unused-parameter

ifdef TILES
  ifndef CONTRIB_SDL
    SDL_CFLAGS := $(shell sdl-config --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include/SDL")
    SDL_LDFLAGS := $(shell sdl-config --libs 2> /dev/null && echo "-lSDL_image" || echo "../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a")
  else
    SDL_CFLAGS := -I../contrib/install/$(ARCH)/include/SDL
    SDL_LDFLAGS := ../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a
  endif

  ifndef NO_PKGCONFIG
    PNG_INCLUDE := $(shell pkg-config libpng --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include")
    PNG_LIB := $(shell pkg-config libpng --libs 2> /dev/null || echo "../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a")
  else
    PNG_INCLUDE := -I../contrib/install/$(ARCH)/include
    PNG_LIB := ../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a
  endif

  CFLAGS += $(SDL_CFLAGS) $(PNG_INCLUDE)
  LDFLAGS += $(SDL_LDFLAGS) $(PNG_LIB)

  CFLAGS += -DUSE_TILE
endif

ifdef DEBUG
CFLAGS += -O0 -DDEBUG -ggdb
endif

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lgdi32 -lwinmm
endif
ifeq ($(uname_S),Darwin)
LDFLAGS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL
endif
ifeq ($(uname_S),Linux)
LDFLAGS += -ldl -lpthread
endif

# Attempt to use a full compiler name, to make
# distcc builds work nicely.
LMACH := $(shell gcc -dumpmachine)-
ifeq ($(LMACH),-)
LMACH :=
endif
ifeq ($(shell which $(LMACH)gcc > /dev/null 2> /dev/null && echo "Yes"),)
LMACH :=
endif
HOSTCXX ?= $(LMACH)g++

DELETE = rm -f

TOOLDIR := tool
TILEGEN := $(TOOLDIR)/tilegen.elf

INPUTS := main dngn floor wall feat player gui icons
INPUTFILES := $(INPUTS:%=dc-%.txt)
HEADERS := $(INPUTS:%=tiledef-%.h)
HTML := $(INPUTS:%=tile-%.html)
SOURCE := $(INPUTS:%=tiledef-%.cc)
IMAGES := $(INPUTS:%=%.png)
JAVASCRIPT := $(INPUTS:%=tileinfo-%.js)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_HOSTCXX  = @echo '   ' HOSTCXX $@;
        QUIET_GEN      = @echo '   ' GEN $(lastword $(subst -, ,$*));
        QUIET_HOSTLINK = @echo '   ' HOSTLINK $@;
        export V
endif
endif

BASE_OBJECTS := tile_colour.o tile.o tile_page.o tile_list_processor.o main.o

# MSVCRT's tmpfile() is broken, so use our own version instead.
ifneq (,$(findstring MINGW,$(uname_S)))
BASE_OBJECTS += tmpfile.o
endif

OBJECTS := $(BASE_OBJECTS:%=$(TOOLDIR)/%)

all: $(TILEGEN) $(HEADERS) $(SOURCE) $(JAVASCRIPT)
ifdef TILES
all: $(IMAGES)
endif

%.png tiledef-%.h tiledef-%.cc tileinfo-%.js: dc-%.txt $(TILEGEN)
	$(QUIET_GEN)$(TILEGEN) $<

# CFLAGS difference check
TRACK_CFLAGS = $(subst ','\'',$(HOSTCXX) $(CFLAGS))           # (stray ' for highlights)

.cflags: .force-cflags
	@FLAGS='$(TRACK_CFLAGS)'; \
    if test x"$$FLAGS" != x"`cat .cflags 2>/dev/null`" ; then \
        echo "    * rebuilding crawl: new build flags or prefix"; \
        echo "$$FLAGS" > .cflags; \
    fi

.PHONY: .force-cflags

##########################################################################
# Dependencies 

gui.png tiledef-gui.h tileinfo-gui.js: dc-spells.txt dc-skills.txt dc-commands.txt
main.png tiledef-main.h tileinfo-main.js: dc-item.txt dc-unrand.txt dc-corpse.txt dc-misc.txt
player.png tiledef-player.h tileinfo-player.js: dc-mon.txt dc-tentacles.txt dc-zombie.txt dc-demon.txt

DEPS := $(OBJECTS:%.o=%.d) $(INPUTS:%=%.d)

-include $(DEPS)

clean:
	$(DELETE) $(HEADERS) $(OBJECTS) $(TILEGEN) $(SOURCE) $(IMAGES) $(HTML) \
		$(DEPS) $(JAVASCRIPT) .cflags tiledef-unrand.cc

distclean: clean

%.o: %.cc .cflags
	$(QUIET_HOSTCXX)$(HOSTCXX) $(CFLAGS) -Wp,-MD,$*.d,-MT,$@ -c $< -o $@

$(TILEGEN): $(OBJECTS)
	$(QUIET_HOSTLINK)$(HOSTCXX) $(OBJECTS) -o $@ $(LDFLAGS)

.PHONY: all clean distclean

=== debian/changelog ===
crawl (2:0.10.2-2) unstable; urgency=low

  * Build-Depend on libpng-dev.

 -- Guus Sliepen <guus@debian.org>  Sat, 14 Apr 2012 18:21:54 +0200

crawl (2:0.10.2-1) unstable; urgency=low

  * New upstream bugfix release. Closes: #668321
  * Tell the makefile to not strip instead of patching that out.
  * Install the SVG icon as .svg rather than .png.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 12 Apr 2012 18:19:04 +0200

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
-ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" $(CROSS)
+ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS)
 ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
 	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
 	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
@@ -91,7 +91,7 @@
 		usr/share/icons/hicolor/32x32/apps/crawl.png
 	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps
 	cp -p source/util/dcss.svg \
-		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.png
+		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.svg
 
 # Build architecture-independent files here.
 binary-indep: install

## crawl 0.10.3

=== source/Makefile ===
--- 
+++ 
@@ -45,6 +45,11 @@
 #    ASSERTS       -- set to enable assertion checks (implied in debug mode)
 #    NOWIZARD      -- set to disable wizard mode.  Use if you have untrusted
 #                     remote players without DGL.
+#
+#    PROPORTIONAL_FONT -- set to a .ttf file you want to use for a proportional
+#                         font; if not set, a copy of Bitstream Vera Sans
+#                         shipped with Crawl will be used
+#    MONOSPACED_FONT   -- monospaced font; Bitstream Vera Mono Sans
 #
 #    WEBTILES      -- set to anything to compile for Webtiles
 #    WEBDIR        -- place to hold the Webtiles client data. Can be either
@@ -444,6 +449,3 @@
 CFLAGS_ARCH := -arch $(MARCH)
 endif
 
-CC = $(GCC) $(CFLAGS_ARCH) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)
-CXX = $(GXX) $(CFLAGS_ARCH) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)
-DEPCC = $(GCC) $(or $(CFLAGS_DEPCC_ARCH),$(CFLAGS_ARCH)) -isysroot $(SDKROOT) -mmacosx-version-min=$(SDK_VER)

=== debian/changelog ===
crawl (2:0.10.3-3) unstable; urgency=low

  * Work around dpkg failing to replace a directory with a symlink.
    Closes: #692947

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 15 Nov 2012 13:54:14 +0100

crawl (2:0.10.3-2) unstable; urgency=low

  * Never #define NEED_FAKE_FDATASYNC; all platforms supported by Debian
    have a working fdatasync().

 -- Guus Sliepen <guus@debian.org>  Wed, 20 Jun 2012 13:19:32 +0200

crawl (2:0.10.3-1) unstable; urgency=low

  * New upstream bugfix release.
    * Includes a workaround for miscompilation (amd64) or FTBFS (certain
      other architectures) on gcc-4.7, caused by
      http://gcc.gnu.org/bugzilla/show_bug.cgi?id=53330
  * Fix CPPFLAGS set by dpkg-buildflags being ignored (-D_FORTIFY_SOURCE=2).
  * Spam the hell out of build logs, overridable by DEB_BUILD_OPTIONS=terse.
    Closes: #668987

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 14 Jun 2012 11:41:30 +0200

=== debian/control ===
Source: crawl
Section: games
Priority: optional
Maintainer: Guus Sliepen <guus@debian.org>
Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
DM-Upload-Allowed: yes
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
	libfreetype6-dev, advancecomp, libpng-dev
Homepage: http://crawl.develz.org/

Package: crawl-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: crawl | crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the data and support files.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Description: Dungeon Crawl, a text-based roguelike game
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the console version, for tiles, use crawl-tiles instead.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl-tiles
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), ttf-dejavu
Description: Dungeon Crawl, a roguelike game, tiles version
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the graphical (tiles) version.
 .
 This is the Stone Soup version of Dungeon Crawl.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,13 @@
 	DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) noopt
   endif
 endif
-CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) $(shell dpkg-buildflags --get LDFLAGS)
+CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
+             $(shell dpkg-buildflags --get LDFLAGS) \
+             $(shell dpkg-buildflags --get CPPFLAGS)
+
+ifeq (,$(filter terse%,$(DEB_BUILD_OPTIONS))$(filter quiet%,$(DEB_BUILD_OPTIONS)))
+        VERBOSE=V=y
+endif
 
 tree-stamp:
 	dh_testdir
@@ -28,7 +34,7 @@
 endif
 
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
-ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS)
+ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS) $(VERBOSE)
 ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
 	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
 	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
